"use strict";

var co = require('co');

var inc_build = require('../scripts/inc_build');
var inc_version = require('../scripts/inc_version');

module.exports = exports = function command__inc(program) {
	program
		.command('inc-build')
        .description('increment package `build_number`')
        .action(co.wrap(function* (cmd) {
            console.log('incrementing module build_number');
            
            try {
                yield inc_build();

                process.exit(0);
            }
            catch (e) {
                console.log(e.stack);

                process.exit(1);
            }
        }));
        
	program
		.command('inc-version')
        .description('increment package `version`')
        .option('-l, --level', 'increment semver level. e.g. minor')
        .action(co.wrap(function* (cmd) {
            console.log('incrementing module version');
            
            try {
                yield inc_version(cmd);

                process.exit(0);
            }
            catch (e) {
                console.log(e.stack);

                process.exit(1);
            }
        }));
};
