"use strict";

/*!
 * @wistla/util#lib/distinct.js
 *
 * Copyright 2017 Wistla Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

module.exports = exports = function distinct(items, property) {
    if (!Array.isArray(items)) {
        throw new TypeError(`@wistla/util#distinct expected \`[object Array]\` but received \'${Object.prototype.toString.call(items)}\' instead.`);
    }
    
    let distinct_items = items.reduce((acc, item) => {
        acc[item[property]] = item;
        
        return acc;
    }, {});
    
    return Object.keys(distinct_items).map(item_id => distinct_items[item_id]);
};
