"use strict";

/*!
 * @wistla/util#lib/fixed.js
 *
 * Copyright 2017 Wistla Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

module.exports = exports = function toFixed(n) {
    if (Math.abs(n) < 1.0) {
        let e = parseInt(n.toString().split('e-')[1]);
        
        if (e) {
            n *= Math.pow(10, e - 1);
            
            n = '0.' + (new Array(e)).join('0') + n.toString().substring(2);
        }
    }
    else {
        let e = parseInt(n.toString().split('+')[1]);
        
        if (e > 20) {
            e -= 20;
            
            n /= Math.pow(10, e);
            
            n += (new Array(e + 1)).join('0');
        }
    }
    
    return n;
};
