"use strict";

var { execSync } = require('child_process');

var path = require('path');

var co = require('co');
var fs = require('mz/fs');
var semver = require('semver');

var { pad } = require('@package/string');
var { assign, bless, coerce, value } = require('@package/value');

const TOP_LEVEL_PACKAGE_PATH = `${process.cwd()}/package.json`;

var metadata = require(TOP_LEVEL_PACKAGE_PATH);

var IS_NAN = require('../lib/isNaN');

module.exports = exports = function* inc_build() {
    const BUILD_NUMBER_KEY = 'wistla.build_number';
    
//    coerce(value(metadata, BUILD_NUMBER_KEY));
    let build_number = execSync(`git rev-list HEAD --count`, {
        cwd: process.cwd()
    });
    
    build_number = pad(build_number, 5);
    
//    if (IS_NAN(build_number)) {
//        build_number = 0;
//    }
    
    console.log(`CURRENT VERSION__BUILD NUMBER: v${metadata.version}__${build_number}`);
    
    assign(metadata, BUILD_NUMBER_KEY, build_number);
    
    yield fs.writeFile(TOP_LEVEL_PACKAGE_PATH, JSON.stringify(metadata, null, 4), 'utf8');
    
    console.log(`NEW VERSION__BUILD NUMBER: v${metadata.version}__${value(metadata, BUILD_NUMBER_KEY)}`);
};
