"use strict";

var { execSync } = require('child_process');

var path = require('path');

var co = require('co');
var fs = require('mz/fs');
var semver = require('semver');

var { pad } = require('@package/string');
var { assign, bless, coerce, value } = require('@package/value');

const TOP_LEVEL_PACKAGE_PATH = `${process.cwd()}/package.json`;

var metadata = require(TOP_LEVEL_PACKAGE_PATH);

var IS_NAN = require('../lib/isNaN');
var inc_build = require('./inc_build');

module.exports = exports = function* inc_version(level = 'patch') {
    const BUILD_NUMBER_KEY = 'wistla.build_number';
    
    let build_number = value(metadata, BUILD_NUMBER_KEY);
    
    if (!build_number) {
        yield inc_build;
        
        build_number = value(metadata, BUILD_NUMBER_KEY);
    }
    
    console.log(`CURRENT VERSION__BUILD NUMBER: v${metadata.version}__${build_number}`);
    
    assign(metadata, 'version', semver.inc(metadata.version, level));
    
    yield fs.writeFile(TOP_LEVEL_PACKAGE_PATH, JSON.stringify(metadata, null, 4), 'utf8');
    
    console.log(`NEW VERSION__BUILD NUMBER: v${metadata.version}__${build_number}`);
};
