"use strict";

var { execSync } = require('child_process');

var path = require('path');

var co = require('co');
var fs = require('mz/fs');
var semver = require('semver');

var { pad } = require('@package/string');
var { assign, bless, coerce, value } = require('@package/value');

const TOP_LEVEL_PACKAGE_PATH = `${process.cwd()}/package.json`;

var metadata = require(TOP_LEVEL_PACKAGE_PATH);

var IS_NAN = require('../lib/isNaN');
var inc_build = require('./inc_build');

module.exports = exports = function* sync_versions() {
    const PREFIX = '@wistla';
    
    [
        'dependencies',
        'devDependencies',
        'optionalDependencies'
    ].forEach(dependency => {
        let dependencies = metadata[dependency];
        
        Object.keys(dependencies).forEach(item => {
            if (item.startsWith(PREFIX)) {
                let package_json = require(`${item}/package.json`);
                
                console.log(`${item}: ${package_json.version}`);
                dependencies[item] = `${semver.major(package_json.version)}.${semver.minor(package_json.version)}.x`;
            }
        });
    });
    
    yield fs.writeFile(TOP_LEVEL_PACKAGE_PATH, JSON.stringify(metadata, null, 4), 'utf8');
};
